﻿using System;
using System.Linq;
using Microsoft.EntityFrameworkCore;

namespace Publications
{
    class Program
    {
        static PublicationsContext _context = new PublicationsContext();
        static void Main(string[] args) =>
            //QueryAuthorArticleCountView();
            //QueryOneToOne();
            //QueryArticleCountViewWithArticle();

            //MagazineStats();
            //QueryTypeFromSql();
            //PublisherQuery();
            QueryOneToManyView();
          

        private static void QueryOneToManyView()
        {
            var articles=_context.Query<ArticleView>().Include(m=>m.Magazine).ToList();
        }

        private static void QueryIssuesWithMags()
        {
           _context.Query<IssueView>().Include(i=>i.Magazine).ToList();
        }

        private static void QueryArticleCountViewWithArticle()
        {
          // var results=_context.Query<AuthorArticleCount>().Include(a=>a.Article).ToList();
        }

        private static void PublisherQuery()
        {
            var publishers=_context.Query<Publisher>().FromSql("select name, yearfounded from publishers").ToList();

        }

        private static void QueryTypeFromSql()
        {
           
            var anonymous=_context.Authors.FromSql("select authorid,authorname from authors").ToList();
}

        private static void MagazineStats()
        {
            // var results=_context.Magazines
            // .Select(m=>new{m.Name,
            //                TheCount=m.Articles.Count,
            //                uniqueauthors=m.Articles.Select(a=>a.AuthorId).Distinct().Count()
            //                }
            // ).ToList();
            var results=_context.Query<MagazineStatsView>().ToList();
        }

        private static void QueryAuthorArticleCountView()
        {
            //var results = _context.AuthorArticleCounts.ToList();
            var results=_context.Query<AuthorArticleCount>().ToList();
        }
        private static void QueryOneToOne()
        {
           var results = _context.AuthorArticleCounts.Include(a=>a.Author).ToList();
        }
    }
}
